(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('soid-ui-util'), require('@angular/platform-browser'), require('@angular/material/icon'), require('interactjs'), require('@angular/common'), require('@angular/platform-browser/animations'), require('@angular/material/slider'), require('@towify/components'), require('ngx-color/sketch'), require('@angular/material/button-toggle'), require('@angular/material/checkbox'), require('@angular/material/tooltip'), require('@angular/material/menu'), require('@angular/material/divider')) :
    typeof define === 'function' && define.amd ? define('towify-editor-color-picker', ['exports', '@angular/core', 'soid-ui-util', '@angular/platform-browser', '@angular/material/icon', 'interactjs', '@angular/common', '@angular/platform-browser/animations', '@angular/material/slider', '@towify/components', 'ngx-color/sketch', '@angular/material/button-toggle', '@angular/material/checkbox', '@angular/material/tooltip', '@angular/material/menu', '@angular/material/divider'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['towify-editor-color-picker'] = {}, global.ng.core, global.soidUiUtil, global.ng.platformBrowser, global.ng.material.icon, global.interact, global.ng.common, global.ng.platformBrowser.animations, global.ng.material.slider, global.components, global.sketch, global.ng.material.buttonToggle, global.ng.material.checkbox, global.ng.material.tooltip, global.ng.material.menu, global.ng.material.divider));
}(this, (function (exports, i0, soidUiUtil, platformBrowser, icon, interact, common, animations, slider, components, sketch, buttonToggle, checkbox, tooltip, menu, divider) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var interact__default = /*#__PURE__*/_interopDefaultLegacy(interact);

    var TowifyEditorColorPickerService = /** @class */ (function () {
        function TowifyEditorColorPickerService() {
        }
        return TowifyEditorColorPickerService;
    }());
    TowifyEditorColorPickerService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function TowifyEditorColorPickerService_Factory() { return new TowifyEditorColorPickerService(); }, token: TowifyEditorColorPickerService, providedIn: "root" });
    TowifyEditorColorPickerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    TowifyEditorColorPickerService.ctorParameters = function () { return []; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    /*
     * @author allen
     * @data 2021/3/25 20:09
     */
    var _TowifyEditorColorPickerComponent_towifyGradientIcons, _TowifyEditorColorPickerComponent_dragItemWidth, _TowifyEditorColorPickerComponent_gradientData, _TowifyEditorColorPickerComponent_spinRadius;
    var TowifyEditorColorPickerComponent = /** @class */ (function () {
        function TowifyEditorColorPickerComponent(sanitizer, matIconRegistry) {
            var _this = this;
            this.sanitizer = sanitizer;
            this.matIconRegistry = matIconRegistry;
            this.width = 220;
            _TowifyEditorColorPickerComponent_towifyGradientIcons.set(this, [
                {
                    name: 'gradient_color',
                    path: 'assets/icons/gradient_color_icon.svg'
                },
                {
                    name: 'gradient_image',
                    path: 'assets/icons/gradient_image_icon.svg'
                },
                {
                    name: 'gradient_linear',
                    path: 'assets/icons/gradient_linear_icon.svg'
                },
                {
                    name: 'gradient_radial',
                    path: 'assets/icons/gradient_radial_icon.svg'
                },
                {
                    name: 'gradient_refresh',
                    path: 'assets/icons/gradient_refresh_icon.svg'
                },
                {
                    name: 'gradient_closest_corner',
                    path: 'assets/icons/gradient_closest_corner_icon.svg'
                },
                {
                    name: 'gradient_closest_side',
                    path: 'assets/icons/gradient_closest_side_icon.svg'
                },
                {
                    name: 'gradient_farthest_corner',
                    path: 'assets/icons/gradient_farthest_corner_icon.svg'
                },
                {
                    name: 'gradient_farthest_side',
                    path: 'assets/icons/gradient_farthest_side_icon.svg'
                },
                {
                    name: 'gradient_drag_icon',
                    path: 'assets/icons/gradient_drag_icon.svg'
                }
            ]);
            this.colorInfo = { color: '#ffffff', opacity: 1 };
            this.onGradientChangeComplete = new i0.EventEmitter();
            this.onGradientChange = new i0.EventEmitter();
            this.onColorChange = new i0.EventEmitter();
            this.onColorChangeComplete = new i0.EventEmitter();
            this.onButtonToggleChanged = new i0.EventEmitter();
            this.backgroundSettings = [
                {
                    icon: 'gradient_color',
                    name: 'Background Color',
                    type: 'color'
                },
                {
                    icon: 'gradient_linear',
                    name: 'Linear Gradient',
                    type: 'linear'
                },
                {
                    icon: 'gradient_radial',
                    name: 'Radial Gradient',
                    type: 'radial'
                },
                {
                    icon: 'gradient_image',
                    name: 'Overlay',
                    type: 'overlay'
                }
            ];
            this.radialInfo = [
                {
                    type: 'closest-side',
                    icon: 'gradient_closest_side',
                    name: 'Closest side',
                    description: 'Closest side extends the gradient from the defined position to the closest side.'
                },
                {
                    type: 'closest-corner',
                    icon: 'gradient_closest_corner',
                    name: 'Closest corner',
                    description: 'Closest corner extends the gradient from the defined position to the closest corner.'
                },
                {
                    type: 'farthest-side',
                    icon: 'gradient_farthest_side',
                    name: 'Farthest side',
                    description: 'Farthest side extends the gradient from the defined position to the farthest side.'
                },
                {
                    type: 'farthest-corner',
                    icon: 'gradient_farthest_corner',
                    name: 'Farthest corner',
                    description: 'Farthest corner extends the gradient from the defined position to the farthest corner.'
                }
            ];
            this.gradientAddCursor = 'copy';
            this.selectedColorIndex = 0;
            this.dragItemHeight = 14;
            _TowifyEditorColorPickerComponent_dragItemWidth.set(this, 8);
            _TowifyEditorColorPickerComponent_gradientData.set(this, void 0);
            this.defaultGradient = {
                shared: {
                    repeat: false,
                    colors: [
                        {
                            hex: '#000000',
                            opacity: 100,
                            percent: 0
                        },
                        {
                            hex: '#ffffff',
                            opacity: 100,
                            percent: 100
                        }
                    ]
                },
                linear: {
                    angle: 180
                },
                radial: {
                    left: 50,
                    top: 50,
                    sizeType: 'farthest-corner'
                }
            };
            this.dragPointPosition = {
                x: 13,
                y: 23
            };
            this.dragOperatorButtonPosition = {
                x: 22,
                y: 22
            };
            _TowifyEditorColorPickerComponent_spinRadius.set(this, {
                button: 16,
                point: 3
            });
            __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_towifyGradientIcons, "f").forEach(function (icon) {
                _this.matIconRegistry.addSvgIcon(icon.name, _this.sanitizer.bypassSecurityTrustResourceUrl(icon.path));
            });
        }
        Object.defineProperty(TowifyEditorColorPickerComponent.prototype, "gradientInfo", {
            get: function () {
                return __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_gradientData, "f");
            },
            set: function (info) {
                var _this = this;
                __classPrivateFieldSet(this, _TowifyEditorColorPickerComponent_gradientData, info !== null && info !== void 0 ? info : JSON.parse(JSON.stringify(this.defaultGradient)), "f");
                this.resetGradientInfo();
                setTimeout(function () {
                    _this.prepareCanvas();
                    if (!info)
                        _this.onGradientChanged();
                }, 0);
            },
            enumerable: false,
            configurable: true
        });
        TowifyEditorColorPickerComponent.prototype.ngOnInit = function () {
            this.dragButton && this.initSpinButtonDragEvent(this.dragButton.nativeElement);
        };
        TowifyEditorColorPickerComponent.prototype.onColorChanging = function (info) {
            this.colorInfo = info;
            this.onColorChange.emit(info);
        };
        TowifyEditorColorPickerComponent.prototype.onColorChanged = function (info) {
            this.colorInfo = info;
            this.onColorChangeComplete.emit(info);
        };
        TowifyEditorColorPickerComponent.prototype.onGradientChanging = function () {
            this.onGradientChange.emit(this.gradientInfo);
        };
        TowifyEditorColorPickerComponent.prototype.onGradientChanged = function () {
            this.onGradientChangeComplete.emit(this.gradientInfo);
        };
        TowifyEditorColorPickerComponent.prototype.switchBoardByType = function (type) {
            var _this = this;
            var _a;
            this.currentType = type;
            this.onButtonToggleChanged.emit(type);
            if (type === 'linear' || type === 'radial') {
                (_a = this.gradientInfo) !== null && _a !== void 0 ? _a : (this.gradientInfo = JSON.parse(JSON.stringify(this.defaultGradient)));
                this.resetGradientInfo();
                this.onGradientChanged();
                setTimeout(function () {
                    _this.prepareCanvas();
                }, 0);
            }
            else if (this.colorInfo) {
                this.onColorChanging(this.colorInfo);
            }
        };
        TowifyEditorColorPickerComponent.prototype.prepareCanvas = function () {
            var _a;
            var rect = (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getBoundingClientRect();
            if (!rect)
                return;
            this.drawCanvasGradient();
            this.initGradientItemDragEvent(rect.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"));
        };
        TowifyEditorColorPickerComponent.prototype.resetGradientInfo = function () {
            var _a, _b;
            var _c, _d;
            if (this.currentType === 'linear') {
                (_a = (_c = this.gradientInfo).linear) !== null && _a !== void 0 ? _a : (_c.linear = { angle: 180 });
                this.dragPointPosition = soidUiUtil.ColorGradientUtils.getPointByAngleInfo({
                    angle: this.gradientInfo.linear.angle,
                    radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                    pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
                    offset: 3
                });
            }
            if (this.currentType === 'radial') {
                (_b = (_d = this.gradientInfo).radial) !== null && _b !== void 0 ? _b : (_d.radial = {
                    left: 50,
                    top: 50,
                    sizeType: 'farthest-corner'
                });
                this.changeDragOperatorButtonPosition();
            }
        };
        TowifyEditorColorPickerComponent.prototype.initSpinButtonDragEvent = function (element) {
            var _this = this;
            if (interact__default['default'].isSet(element))
                return;
            var deltaX;
            var deltaY;
            var changeX;
            var changeY;
            var alignPoint;
            var spinButtonPosition;
            var recalculateAngleValue = function (event) {
                var _a;
                if (!((_a = _this.gradientInfo) === null || _a === void 0 ? void 0 : _a.linear))
                    return;
                deltaX = event.dx;
                deltaY = event.dy;
                changeX = spinButtonPosition.x + deltaX;
                changeY = spinButtonPosition.y + deltaY;
                alignPoint = soidUiUtil.ColorGradientUtils.getAlignPointByPointInfo({
                    point: { x: changeX, y: changeY },
                    radius: __classPrivateFieldGet(_this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                    pointRadius: __classPrivateFieldGet(_this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
                    offset: 3
                });
                _this.gradientInfo.linear.angle = soidUiUtil.ColorGradientUtils.getAngleByPointInfo({
                    point: alignPoint,
                    radius: __classPrivateFieldGet(_this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                    pointRadius: __classPrivateFieldGet(_this, _TowifyEditorColorPickerComponent_spinRadius, "f").point
                });
                _this.dragPointPosition = alignPoint;
            };
            interact__default['default'](element).draggable({
                listeners: {
                    start: function () {
                        spinButtonPosition = _this.dragPointPosition;
                    },
                    move: function (event) {
                        recalculateAngleValue(event);
                        _this.onGradientChanging();
                        spinButtonPosition.x = changeX;
                        spinButtonPosition.y = changeY;
                    },
                    end: function (event) {
                        recalculateAngleValue(event);
                        _this.onGradientChanged();
                        _this.dragPointPosition = alignPoint;
                        spinButtonPosition.x = 0;
                        spinButtonPosition.y = 0;
                    }
                }
            });
        };
        TowifyEditorColorPickerComponent.prototype.initPositionOperatorButtonDragEvent = function (element) {
            var _this = this;
            if (interact__default['default'].isSet(element))
                return;
            var changeX;
            var changeY;
            var operatorButtonPosition;
            var positionBoardSize = 44;
            var recalculateShadowValue = function (event) {
                var _a;
                if (!((_a = _this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
                    return;
                changeX += event.dx;
                changeY += event.dy;
                _this.dragOperatorButtonPosition.x = operatorButtonPosition.x + changeX;
                _this.dragOperatorButtonPosition.y = operatorButtonPosition.y + changeY;
                _this.dragOperatorButtonPosition.x = soidUiUtil.NumberUtils.convertValueInRange(_this.dragOperatorButtonPosition.x, positionBoardSize, 0);
                _this.dragOperatorButtonPosition.y = soidUiUtil.NumberUtils.convertValueInRange(_this.dragOperatorButtonPosition.y, positionBoardSize, 0);
                _this.gradientInfo.radial.left = parseFloat(((_this.dragOperatorButtonPosition.x / positionBoardSize) *
                    100).toFixed());
                _this.gradientInfo.radial.top = parseFloat(((_this.dragOperatorButtonPosition.y / positionBoardSize) *
                    100).toFixed());
            };
            interact__default['default'](element).draggable({
                listeners: {
                    start: function () {
                        operatorButtonPosition = Object.assign({}, _this.dragOperatorButtonPosition);
                        changeX = 0;
                        changeY = 0;
                    },
                    move: function (event) {
                        recalculateShadowValue(event);
                        _this.onGradientChanging();
                    },
                    end: function (event) {
                        recalculateShadowValue(event);
                        _this.onGradientChanged();
                        operatorButtonPosition.x = 0;
                        operatorButtonPosition.y = 0;
                        changeX = 0;
                        changeY = 0;
                    }
                }
            });
        };
        TowifyEditorColorPickerComponent.prototype.onAngleChanged = function (angle, needToSync) {
            if (needToSync === void 0) { needToSync = false; }
            var _a;
            if (angle === null)
                return;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.linear))
                return;
            var getCorrectAngle = function (angle) {
                var result = angle;
                if (result > 360)
                    result %= 360;
                if (result < 0)
                    result = (result % 360) + 360;
                return result;
            };
            this.gradientInfo.linear.angle = getCorrectAngle(angle);
            this.dragPointPosition = soidUiUtil.ColorGradientUtils.getPointByAngleInfo({
                angle: this.gradientInfo.linear.angle,
                radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
                offset: 3
            });
            if (needToSync) {
                this.onGradientChanged();
            }
            else {
                this.onGradientChanging();
            }
        };
        TowifyEditorColorPickerComponent.prototype.onRadialLeftPositionChanged = function (left) {
            var _a;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
                return;
            this.gradientInfo.radial.left = soidUiUtil.NumberUtils.convertValueInRange(left);
            this.changeDragOperatorButtonPosition();
            this.onGradientChanged();
        };
        TowifyEditorColorPickerComponent.prototype.onRadialTopPositionChanged = function (top) {
            var _a;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
                return;
            this.gradientInfo.radial.top = soidUiUtil.NumberUtils.convertValueInRange(top);
            this.changeDragOperatorButtonPosition();
            this.onGradientChanged();
        };
        TowifyEditorColorPickerComponent.prototype.addColorGradient = function (event) {
            var _a, _b;
            if (!this.gradientInfo)
                return;
            var canvasContext = (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getContext('2d');
            var canvasRect = (_b = this.gradientCanvas) === null || _b === void 0 ? void 0 : _b.nativeElement.getBoundingClientRect();
            if (canvasContext && canvasRect) {
                var clickPoint = {
                    x: event.clientX - canvasRect.x,
                    y: event.clientY - canvasRect.y
                };
                var clickColorData = canvasContext.getImageData(clickPoint.x, clickPoint.y, 1, 1).data;
                var percent = soidUiUtil.NumberUtils.convertValueInRange(Math.round((clickPoint.x / (canvasRect.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"))) * 100));
                this.gradientInfo.shared.colors.push({
                    percent: percent,
                    hex: soidUiUtil.ColorUtils.rgbToHex(clickColorData[0], clickColorData[1], clickColorData[2]),
                    opacity: parseFloat(((clickColorData[3] / 255) * 100).toFixed(0))
                });
                this.selectedColorIndex = this.gradientInfo.shared.colors.length - 1;
                this.sortColor();
                this.drawCanvasGradient(canvasContext);
            }
            this.onGradientChanged();
        };
        TowifyEditorColorPickerComponent.prototype.reverseColorGradient = function () {
            if (!this.gradientInfo)
                return;
            var colorLength = this.gradientInfo.shared.colors.length;
            var index = 0;
            var tempPercent = 0;
            for (index; index < colorLength / 2; index += 1) {
                tempPercent = this.gradientInfo.shared.colors[index].percent;
                this.gradientInfo.shared.colors[index].percent = this.gradientInfo.shared.colors[colorLength - 1 - index].percent;
                this.gradientInfo.shared.colors[colorLength - 1 - index].percent = tempPercent;
            }
            this.sortColor();
            this.drawCanvasGradient();
            this.onGradientChanged();
        };
        TowifyEditorColorPickerComponent.prototype.onSelectedColorChange = function (color, needToSync) {
            if (needToSync === void 0) { needToSync = false; }
            var _a;
            if ((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[this.selectedColorIndex]) {
                this.gradientInfo.shared.colors[this.selectedColorIndex].hex =
                    color.hex === 'transparent' ? '#000000' : color.hex;
                this.gradientInfo.shared.colors[this.selectedColorIndex].opacity =
                    color.rgb.a * 100;
                this.drawCanvasGradient();
                if (needToSync) {
                    this.onGradientChanged();
                }
                else {
                    this.onGradientChanging();
                }
            }
        };
        TowifyEditorColorPickerComponent.prototype.onSelectedPercentChange = function (percent, isListening) {
            if (isListening === void 0) { isListening = false; }
            var _a;
            if (percent === null)
                return;
            if ((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[this.selectedColorIndex]) {
                this.gradientInfo.shared.colors[this.selectedColorIndex].percent = soidUiUtil.NumberUtils.convertValueInRange(percent);
                this.sortColor();
                this.drawCanvasGradient();
                if (isListening) {
                    this.onGradientChanging();
                }
                else {
                    this.onGradientChanged();
                }
            }
        };
        TowifyEditorColorPickerComponent.prototype.initGradientItemDragEvent = function (maxWidth) {
            var _this = this;
            if (maxWidth <= 0)
                return;
            var changeX = 0;
            var startPercent = 0;
            interact__default['default']('.gradient-drag-item')
                .draggable({
                cursorChecker: function () { return 'ew-resize'; },
                listeners: {
                    start: function () {
                        var _a, _b;
                        startPercent = (_b = (_a = _this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[_this.selectedColorIndex]) === null || _b === void 0 ? void 0 : _b.percent;
                        changeX = 0;
                        _this.gradientAddCursor = 'ew-resize';
                    },
                    move: function (event) {
                        changeX += event.dx;
                        _this.onSelectedPercentChange(startPercent + Math.round((changeX / maxWidth) * 100), true);
                    },
                    end: function (event) {
                        changeX += event.dx;
                        _this.onSelectedPercentChange(startPercent + Math.round((changeX / maxWidth) * 100));
                        changeX = 0;
                        startPercent = 0;
                        _this.gradientAddCursor = 'copy';
                    }
                }
            })
                .styleCursor(false);
        };
        TowifyEditorColorPickerComponent.prototype.changeDragOperatorButtonPosition = function () {
            var _a;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
                return;
            this.dragOperatorButtonPosition.x =
                (this.gradientInfo.radial.left / 100) * 44;
            this.dragOperatorButtonPosition.y =
                (this.gradientInfo.radial.top / 100) * 44;
        };
        TowifyEditorColorPickerComponent.prototype.sortColor = function () {
            var _this = this;
            if (!this.gradientInfo)
                return;
            var selectedColor = this.gradientInfo.shared.colors[this.selectedColorIndex];
            var findSelected = false;
            this.gradientInfo.shared.colors
                .sort(function (a, b) { return (a.percent < b.percent ? -1 : 1); })
                .forEach(function (colorInfo, index) {
                if (colorInfo === selectedColor) {
                    findSelected = true;
                    _this.selectedColorIndex = index;
                }
            });
            if (!findSelected) {
                this.selectedColorIndex = 0;
            }
        };
        TowifyEditorColorPickerComponent.prototype.drawCanvasGradient = function (canvasContext) {
            var _a, _b;
            var context = canvasContext !== null && canvasContext !== void 0 ? canvasContext : (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getContext('2d');
            if (!context)
                return;
            context.clearRect(0, 0, this.width, this.dragItemHeight);
            var gradient = context.createLinearGradient(0, 0, this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
            (_b = this.gradientInfo) === null || _b === void 0 ? void 0 : _b.shared.colors.forEach(function (colorInfo) {
                gradient.addColorStop(colorInfo.percent / 100, soidUiUtil.ColorUtils.hexToRgba(colorInfo.hex, colorInfo.opacity));
            });
            context.fillStyle = gradient;
            context.fillRect(0, 0, this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
            if (this.gradientInfo && this.gradientInfo.shared.colors.length > 0) {
                var lastColorInfo = this.gradientInfo.shared.colors[this.gradientInfo.shared.colors.length - 1];
                context.fillStyle = soidUiUtil.ColorUtils.hexToRgba(lastColorInfo.hex, lastColorInfo.opacity);
                context.fillRect(this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), 0, __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
            }
        };
        return TowifyEditorColorPickerComponent;
    }());
    _TowifyEditorColorPickerComponent_towifyGradientIcons = new WeakMap(), _TowifyEditorColorPickerComponent_dragItemWidth = new WeakMap(), _TowifyEditorColorPickerComponent_gradientData = new WeakMap(), _TowifyEditorColorPickerComponent_spinRadius = new WeakMap();
    TowifyEditorColorPickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'towify-editor-color-picker',
                    template: "<div class=\"gradient-container\" [style.width.px]=\"width\">\n  <mat-button-toggle-group\n    class=\"background-settings-grid\"\n    [value]=\"currentType\"\n  >\n    <mat-button-toggle\n      *ngFor=\"let item of backgroundSettings\"\n      [value]=\"item.type\"\n      aria-label=\"{{ item.name }}\"\n      matTooltip=\"{{ item.name }}\"\n      (click)=\"switchBoardByType(item.type)\"\n    >\n      <mat-icon [svgIcon]=\"item.icon\"></mat-icon>\n    </mat-button-toggle>\n  </mat-button-toggle-group>\n  <mat-divider></mat-divider>\n  <ng-container [ngSwitch]=\"currentType\">\n    <div class=\"angle-item\" *ngSwitchCase=\"'linear'\">\n      <div class=\"horizontal-item\">\n        <div class=\"spin-button\">\n          <div\n            class=\"spin-mark\"\n            #dragPoint\n            [style.top.px]=\"dragPointPosition.y\"\n            [style.left.px]=\"dragPointPosition.x\"\n          ></div>\n        </div>\n        <mat-slider\n          color=\"primary\"\n          [value]=\"gradientInfo?.linear?.angle\"\n          (input)=\"onAngleChanged($event.value)\"\n          (valueChange)=\"onAngleChanged($event, true)\"\n          [max]=\"360\"\n        ></mat-slider>\n        <towify-mark-input\n          type=\"number\"\n          [max]=\"361\"\n          [min]=\"-1\"\n          [fixContent]=\"'Degree'\"\n          [value]=\"gradientInfo?.linear?.angle\"\n          (onChanged)=\"onAngleChanged($event, true)\"\n        ></towify-mark-input>\n      </div>\n    </div>\n    <div class=\"radial-item\" *ngSwitchCase=\"'radial'\">\n      <div class=\"radial-position-item\">\n        <span> Position </span>\n        <div\n          class=\"radial-position-operator\"\n          [style.background-image]=\"\n            'url(assets/icons/radio_position_board_pattern_icon.svg)'\n          \"\n        >\n          <div\n            class=\"position-operator-button\"\n            #dragButton\n            [style.top.px]=\"dragOperatorButtonPosition.y\"\n            [style.left.px]=\"dragOperatorButtonPosition.x\"\n          >\n            <mat-icon [svgIcon]=\"'gradient_drag_icon'\"></mat-icon>\n            {{ initPositionOperatorButtonDragEvent(dragButton) }}\n          </div>\n        </div>\n        <div class=\"radial-position-container\">\n          <span> Left </span>\n          <towify-mark-input\n            [max]=\"100\"\n            [min]=\"0\"\n            type=\"number\"\n            [fixContent]=\"'%'\"\n            [width]=\"60\"\n            [value]=\"gradientInfo?.radial?.left\"\n            (onChanged)=\"onRadialLeftPositionChanged($event)\"\n          ></towify-mark-input>\n          <span> Top </span>\n          <towify-mark-input\n            [max]=\"100\"\n            [min]=\"0\"\n            type=\"number\"\n            [fixContent]=\"'%'\"\n            [width]=\"60\"\n            [value]=\"gradientInfo?.radial?.top\"\n            (onChanged)=\"onRadialTopPositionChanged($event)\"\n          ></towify-mark-input>\n        </div>\n      </div>\n      <div class=\"type-container\">\n        <span>Size</span>\n        <mat-button-toggle-group\n          class=\"radial-size-toggle-group\"\n          [value]=\"gradientInfo?.radial?.sizeType\"\n        >\n          <mat-button-toggle\n            *ngFor=\"let item of radialInfo\"\n            [value]=\"item.type\"\n            [matTooltip]=\"item.description\"\n            (click)=\" gradientInfo!.radial!.sizeType = item.type; onGradientChanged()\n            \"\n          >\n            <mat-icon [svgIcon]=\"item.icon\"></mat-icon>\n          </mat-button-toggle>\n        </mat-button-toggle-group>\n      </div>\n    </div>\n  </ng-container>\n  <!-- Common Color Selection -->\n  <ng-container *ngIf=\"currentType === 'color'; else gradientSettings\">\n    <div class=\"horizontal-item\">\n      <div\n        class=\"color-preview\"\n        [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n      >\n        <div\n          class=\"color\"\n          [matMenuTriggerFor]=\"colorPicker\"\n          [style.background-color]=\"colorInfo.color\"\n          [style.opacity]=\"colorInfo.opacity / 100\"\n        ></div>\n      </div>\n      <mat-slider\n        [color]=\"'primary'\"\n        thumbLabel\n        [max]=\"100\"\n        [min]=\"0\"\n        [value]=\"colorInfo.opacity\"\n        (input)=\"colorInfo.opacity = $event.value === null ? 1 : $event.value; onColorChanging(colorInfo)\"\n        (valueChange)=\"onColorChanged(colorInfo)\"\n      ></mat-slider>\n      <towify-mark-input\n        [width]=\"80\"\n        [max]=\"100\"\n        [min]=\"0\"\n        type=\"number\"\n        [value]=\"colorInfo.opacity\"\n        [fixContent]=\"'Opacity'\"\n        (onChanged)=\"colorInfo.opacity = $event; onColorChanged(colorInfo)\"\n      ></towify-mark-input>\n    </div>\n  </ng-container>\n  <ng-template #gradientSettings>\n    <div class=\"setting-item\">\n      <div\n        class=\"gradient-preview\"\n        [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n        (mousedown)=\"addColorGradient($event)\"\n        [style.cursor]=\"gradientAddCursor\"\n      >\n        <canvas\n          [width]=\"width\"\n          [height]=\"this.dragItemHeight\"\n          class=\"gradient-canvas\"\n          #gradientCanvas\n        ></canvas>\n        <div class=\"gradient-drag-operator\">\n          <div\n            *ngFor=\"let colorInfo of gradientInfo!.shared.colors; let i = index\"\n            [className]=\"\n              i === selectedColorIndex\n                ? 'gradient-drag-item selected'\n                : 'gradient-drag-item normal'\n            \"\n            [style.background-color]=\"\n              (i === selectedColorIndex ? colorInfo.hex : '')\n                | hexToRgba: colorInfo.opacity\n            \"\n            [style.left]=\"colorInfo.percent + '%'\"\n            (mousedown)=\"selectedColorIndex = i; $event.stopPropagation()\"\n          ></div>\n        </div>\n      </div>\n      <div class=\"repeat-item\">\n        <div>\n          <mat-checkbox\n            color=\"primary\"\n            [checked]=\"gradientInfo!.shared.repeat\"\n            (change)=\"\n              gradientInfo!.shared.repeat = $event.checked; onGradientChanged()\n            \"\n          >\n            <span>Repeat</span>\n          </mat-checkbox>\n        </div>\n        <div\n          class=\"reverse-item\"\n          [title]=\"'Reverse'\"\n          (click)=\"reverseColorGradient()\"\n        >\n          <mat-icon [svgIcon]=\"'gradient_refresh'\"></mat-icon>\n        </div>\n      </div>\n      <div class=\"horizontal-item\">\n        <div\n          class=\"color-preview\"\n          [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n        >\n          <div\n            class=\"color\"\n            [matMenuTriggerFor]=\"gradientColorPicker\"\n            [style.backgroundColor]=\"\n              gradientInfo!.shared.colors[selectedColorIndex]?.hex\n            \"\n            [style.opacity]=\"\n              gradientInfo!.shared.colors[selectedColorIndex]!.opacity / 100\n            \"\n          ></div>\n        </div>\n        <mat-slider\n          color=\"primary\"\n          thumbLabel\n          [max]=\"100\"\n          [value]=\"gradientInfo!.shared.colors[selectedColorIndex]?.percent\"\n          (input)=\"onSelectedPercentChange($event.value, true)\"\n          (valueChange)=\"onSelectedPercentChange($event)\"\n        ></mat-slider>\n        <towify-mark-input\n          [width]=\"80\"\n          [max]=\"100\"\n          [min]=\"0\"\n          type=\"number\"\n          [value]=\"gradientInfo!.shared.colors[selectedColorIndex]?.percent\"\n          [fixContent]=\"'Range'\"\n          (onChanged)=\"onSelectedPercentChange($event)\"\n        ></towify-mark-input>\n      </div>\n    </div>\n  </ng-template>\n</div>\n\n<mat-menu #gradientColorPicker class=\"color-picker\">\n  <color-sketch\n    *ngIf=\"!!gradientInfo\"\n    (click)=\"$event.stopPropagation()\"\n    [disableAlpha]=\"true\"\n    [color]=\"\n      gradientInfo!.shared.colors[selectedColorIndex]!.hex\n        | hexToRgba: gradientInfo!.shared.colors[selectedColorIndex]!.opacity\n    \"\n    (onChange)=\"onSelectedColorChange($event.color)\"\n    (onChangeComplete)=\"onSelectedColorChange($event.color, true)\"\n  ></color-sketch>\n</mat-menu>\n\n<mat-menu #colorPicker class=\"color-picker\">\n  <color-sketch\n    *ngIf=\"!!colorInfo\"\n    (click)=\"$event.stopPropagation()\"\n    [color]=\"colorInfo.color | hexToRgba: colorInfo.opacity\"\n    (onChange)=\"\n      onColorChanging({\n        color: $event.color.hex,\n        opacity: $event.color.rgb.a * 100\n      })\n    \"\n    (onChangeComplete)=\"\n      onColorChanged({\n        color: $event.color.hex,\n        opacity: $event.color.rgb.a * 100\n      })\n    \"\n  ></color-sketch>\n</mat-menu>\n\n",
                    styles: ["*{box-sizing:border-box}a,button,h1,input,label,li,textarea,ul{border:none;outline:none}div{outline:none;-moz-user-select:none;-webkit-user-select:none;-ms-user-select:none;user-select:none;-o-user-select:none}input::-webkit-inner-spin-button,input::-webkit-outer-spin-button{-webkit-appearance:none;margin:0}img{-o-object-fit:cover;object-fit:cover}::-webkit-scrollbar{display:none}.menu-title{font-size:12px;margin:8px 15px;color:rgba(0,0,0,.25);font-weight:700}.mat-form-field{width:100%;font-size:10px}.mat-form-field ::ng-deep .mat-form-field-wrapper{margin:unset}.mat-menu-content .mat-menu-item{line-height:35px;height:35px;font-size:11px;font-family:-apple-system,BlinkMacSystemFont,SF UI Text,Helvetica Neue,PingFang SC,Hiragino Sans GB,Microsoft YaHei UI,Microsoft YaHei,Arial,sans-serif}.mat-expansion-panel-content{display:grid}.cdk-overlay-container .mat-menu-panel{min-width:unset;min-height:unset}:host span{font-family:-apple-system,BlinkMacSystemFont,SF UI Text,Helvetica Neue,PingFang SC,Hiragino Sans GB,Microsoft YaHei UI,Microsoft YaHei,Arial,sans-serif;font-size:10px;color:#ccc}:host .gradient-container{width:100%;display:grid;grid-template-rows:24px auto auto;grid-row-gap:10px}:host .gradient-container .background-settings-grid{display:grid;grid-template-columns:repeat(4,1fr)}:host .gradient-container .mat-button-toggle-group-appearance-standard :first-child{border-left:none}:host .gradient-container .mat-button-toggle-appearance-standard{background-color:#0c0c0c}:host .gradient-container .mat-button-toggle-disabled.mat-button-toggle-appearance-standard{background-color:#222}:host .gradient-container .mat-button-toggle-checked{background-color:#303030}:host ::ng-deep .mat-button-toggle-button{height:100%;display:grid}:host ::ng-deep .mat-button-toggle-label-content{line-height:14px;align-self:center;margin-top:-2px}:host ::ng-deep .mat-button-toggle-label-content .mat-icon{width:14px;height:14px}:host .setting-item{display:grid;align-items:center}:host .spin-button{width:32px;height:32px;background-color:#363636;box-shadow:0 0 3px rgba(0,0,0,.5);border-radius:18px;position:relative}:host .spin-button .spin-mark{touch-action:none;top:13px;left:23px;position:absolute;width:6px;height:6px;background-color:#fff;border-radius:3px}:host .repeat-item{display:grid;grid-template-columns:auto 32px;-moz-column-gap:5px;column-gap:5px;align-items:center;border-top:1px solid #363636;border-bottom:1px solid #363636;margin:5px 0;padding:5px 0}:host .repeat-item ::ng-deep .mat-checkbox-inner-container{width:14px;height:14px}:host .horizontal-item{display:grid;grid-template-columns:40px auto 80px;-moz-column-gap:5px;column-gap:5px;align-items:center}:host .horizontal-item .mat-slider{padding:0}:host .horizontal-item .mat-slider-horizontal{min-width:auto;height:auto}:host .horizontal-item .mat-slider-horizontal ::ng-deep .mat-slider-wrapper{top:0}:host .horizontal-item .mat-form-field{width:75px;font-size:9px;margin-left:5px}:host .horizontal-item .mat-form-field ::ng-deep .mat-form-field-wrapper{padding-bottom:0}:host .angle-item{display:grid;grid-row-gap:10px}:host .radial-item{display:grid;grid-row-gap:6px}:host .radial-item .radial-position-item{display:grid;grid-template-columns:40px 72px auto;-moz-column-gap:4px;column-gap:4px;align-items:center}:host .radial-item .radial-position-item .radial-position-operator{background-color:#2b2b2b;width:68px;height:68px;overflow:hidden;border:1px solid #212121;border-radius:5px;position:relative}:host .radial-item .radial-position-item .radial-position-operator .position-operator-button{position:absolute;display:grid;align-items:center;justify-content:center;width:22px;height:22px}:host .radial-item .radial-position-item .radial-position-operator .position-operator-button .mat-icon{width:18px;height:18px;font-size:18px;line-height:18px}:host .radial-item .radial-position-item .radial-position-container{display:grid;grid-template-columns:1fr auto;align-items:center;gap:4px 4px;justify-items:center}:host .reverse-item{display:grid;justify-content:end;cursor:pointer}:host .reverse-item .mat-icon{width:16px;height:16px}:host .radial-size-toggle-group{width:100%;height:24px;display:grid;grid-template-columns:repeat(4,1fr)}:host .mat-button-toggle-checked{background-color:#2b2b2b}:host ::ng-deep .mat-button-toggle{display:grid;align-items:center}:host .color-preview{border:2px solid hsla(0,0%,100%,.25);border-radius:30px;width:30px;height:30px;justify-self:start;box-shadow:0 2px 5px rgba(0,0,0,.15);overflow:hidden;background-size:30px 30px}:host .color-preview .color{width:100%;height:100%;background-color:#000}:host .gradient-preview{height:16px;overflow:visible;grid-column:1/-1;box-sizing:border-box;border:1px solid rgba(0,0,0,.8);border-radius:2px;position:relative;margin:10px 0}:host .gradient-canvas{position:absolute}:host .gradient-drag-operator{position:absolute;width:calc(100% - 7px);height:100%}:host .gradient-drag-item{touch-action:none;pointer-events:auto;position:absolute;height:calc(100% - 2px);top:1px;width:8px;border-radius:1px;background-color:#ebebeb;opacity:1;cursor:ew-resize}:host .normal{box-shadow:0 0 0 1px rgba(0,0,0,.3)}:host .selected{box-shadow:0 0 0 2px #ebebeb,0 0 0 3px rgba(0,0,0,.3),inset 0 0 0 1px rgba(0,0,0,.3)}:host .color-picker.mat-menu-panel{max-width:200px}:host .color-picker .mat-menu-content:not(:empty){padding-top:0;padding-bottom:0}:host .drag-ghost{width:1px;height:1px;left:1px;top:1px;opacity:0;z-index:-1}"]
                },] }
    ];
    TowifyEditorColorPickerComponent.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer },
        { type: icon.MatIconRegistry }
    ]; };
    TowifyEditorColorPickerComponent.propDecorators = {
        dragButton: [{ type: i0.ViewChild, args: ['dragButton', { read: i0.ElementRef, static: true },] }],
        currentType: [{ type: i0.Input }],
        width: [{ type: i0.Input }],
        gradientInfo: [{ type: i0.Input }],
        colorInfo: [{ type: i0.Input }],
        onGradientChangeComplete: [{ type: i0.Output }],
        onGradientChange: [{ type: i0.Output }],
        onColorChange: [{ type: i0.Output }],
        onColorChangeComplete: [{ type: i0.Output }],
        onButtonToggleChanged: [{ type: i0.Output }],
        gradientCanvas: [{ type: i0.ViewChild, args: ['gradientCanvas', { read: i0.ElementRef },] }]
    };

    /*
     * @author kaysaith
     * @date 2021/5/16
     */
    var HexToRgbaPipe = /** @class */ (function () {
        function HexToRgbaPipe() {
        }
        HexToRgbaPipe.prototype.transform = function (hex, opacity) {
            if (hex === '') {
                return '';
            }
            return soidUiUtil.ColorUtils.hexToRgba(hex, opacity);
        };
        return HexToRgbaPipe;
    }());
    HexToRgbaPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'hexToRgba'
                },] }
    ];

    var TowifyEditorColorPickerModule = /** @class */ (function () {
        function TowifyEditorColorPickerModule() {
        }
        return TowifyEditorColorPickerModule;
    }());
    TowifyEditorColorPickerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        TowifyEditorColorPickerComponent, HexToRgbaPipe
                    ],
                    imports: [
                        common.CommonModule,
                        animations.BrowserAnimationsModule,
                        slider.MatSliderModule,
                        icon.MatIconModule,
                        components.TowifyMarkInputModule,
                        sketch.ColorSketchModule,
                        buttonToggle.MatButtonToggleModule,
                        checkbox.MatCheckboxModule,
                        tooltip.MatTooltipModule,
                        menu.MatMenuModule,
                        divider.MatDividerModule
                    ],
                    exports: [
                        TowifyEditorColorPickerComponent
                    ]
                },] }
    ];

    /*
     * Public API Surface of towify-editor-color-picker
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.TowifyEditorColorPickerComponent = TowifyEditorColorPickerComponent;
    exports.TowifyEditorColorPickerModule = TowifyEditorColorPickerModule;
    exports.TowifyEditorColorPickerService = TowifyEditorColorPickerService;
    exports.ɵa = HexToRgbaPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=towify-editor-color-picker.umd.js.map
